
import java.io.File;
import java.io.IOException;
import java.util.Calendar;
import java.util.Locale;

import com.spire.license.LicenseProvider;
import com.spire.pdf.FileFormat;
import com.spire.pdf.PdfDocument;
import com.spire.pdf.PdfVersion;
import com.spire.xls.CellStyle;
import com.spire.xls.ExcelPicture;
import com.spire.xls.PageOrientationType;
import com.spire.xls.PageSetup;
import com.spire.xls.PaperSizeType;
import com.spire.xls.Workbook;
import com.spire.xls.Worksheet;

public class PPABenchmarkingFlow {

    public static void main(String[] args) throws IOException {
        // Extract the image content using spire xls
        // Convert the sheet as PDF and send it Document ai OCR process
        String licenseKey = "LICENSE_KEY_VALUE";
        LicenseProvider.setLicenseKey(licenseKey);
        String workingDirectory = "G:\\PPA Benchmarking Requests";
        String imagesParentDirectory = workingDirectory + File.separator + "spire8.6.0" + File.separator + "images";
        String pdfPD = workingDirectory + File.separator + "spire8.6.0" + File.separator + "pdf" + File.separator
            + System.nanoTime();
        File file = new File(
            "G:\\PPA Benchmarking Requests\\PPA Benchmarking_V1.1.xlsx");
		
        Locale locale = new Locale("zh", "CN");
        Locale.setDefault(locale);

        System.out.println(Calendar.getInstance().getTime());

        System.out.println(file);
        // System.out.println(outputFileName);

        Workbook workbook = new Workbook();
        workbook.loadFromFile(file.getPath());
        // workbook.getConverterSetting().setSheetFitToWidth(true);
        workbook.getConverterSetting().setSheetFitToPage(true);
        workbook.getConverterSetting().isReCalculateOnConvert(false);

        for (int i = 0; i < workbook.getWorksheets().size(); i++) {

            Worksheet sheet = workbook.getWorksheets().get(i);
            System.out.println("Sheet Name: " + sheet.getName());
            System.out.println("Sheet ID: " + sheet.getSheetId());
            if (sheet.getPictures() != null && sheet.getPictures().size() > 0) {
                String imageDirectory =
                    imagesParentDirectory + File.separator + file.getName() + File.separator + sheet.getName();
                String pdfDirectory = pdfPD + File.separator + file.getName();
                System.out.println("Image Directory Path: " + imageDirectory);
                System.out.println("PDF Directory Path: " + pdfDirectory);
                File imgDir = new File(imageDirectory);
                imgDir.mkdirs();
                System.out.printf("%d images found in the sheet %s%n", sheet.getPictures().size(), sheet.getName());
                for (int j = 0; j < sheet.getPictures().size(); j++) {
                    ExcelPicture pic = sheet.getPictures().get(j);
                    String imagePath = imageDirectory + File.separator + "picture-" + (j + 1) + ".jpg";
                    pic.saveToImage(imagePath);
                    System.out.println("Image created in " + imagePath);
                }
                String pdfPath = pdfDirectory + File.separator + sheet.getName() + ".pdf";
                processSheet(sheet);
                PageSetup pageSetup = sheet.getPageSetup();
                pageSetup.setPrintQuality(600);
                pageSetup.isFitToPage(true);
                pageSetup.setPaperSize(PaperSizeType.LetterPlusPaper);
                pageSetup.setOrientation(PageOrientationType.Portrait);
                // pageSetup.setCustomPaperSize(8.50f, 11.00f);
                // pageSetup.setAlignWithMargins((byte) 1);
                System.out.println("Print area: " + pageSetup.getPrintArea());
                // pageSetup.prin
                sheet.saveToPdf(pdfPath);

                // Create a PdfDocument object
                PdfDocument document = new PdfDocument();

                // Load a sample PDF file
                document.loadFromFile(pdfPath);

                // Change the PDF to version 1.5
                document.getFileInfo().setVersion(PdfVersion.Version_1_7);

                // Save to file
                document.saveToFile(pdfPath, FileFormat.PDF);
                document.close();

            } else {
                System.out.printf("No images found in the sheet %s%n", sheet.getName());
            }

        }
        workbook.dispose();
    }

    protected static void processSheet(Worksheet worksheet) {
        /*if (worksheet.getPivotTables().getCount() == 0) {
            worksheet.CalculateAllValue();
        }*/

        for (int col = worksheet.getFirstColumn(); col <= worksheet.getLastColumn(); col++) {
            // CellStyle style = worksheet.getColumns()[col-1].getCellStyle();
            CellStyle style = worksheet.getDefaultColumnStyle(col);
            style.setWrapText(true);
            // style.setShrinkToFit(true);
        }
        // worksheet.getAllocatedRange().isWrapText(true);
        /*Boolean isRowMerged = false;
        Boolean isColMerged = false;

        CellRange[] rows = worksheet.getRows();
        CellRange[] columns = worksheet.getColumns();

        for (int r = 0; r < rows.length; r++) {
            if (rows[r].hasMerged()) {
                rows[r].autoFitColumns();
                isRowMerged = true;
                break;
            }
        }*/
        /* if (isRowMerged) {
            worksheet.getAllocatedRange().autoFitColumns();
        }*/

        /*for (int r = 0; r < columns.length; r++) {
            if (columns[r].hasMerged()) {
                rows[r].autoFitRows();
                isColMerged = true;
                break;
            }
        }
        if (!isColMerged && !isRowMerged) {
            // worksheet.getAllocatedRange().autoFitColumns();
            // worksheet.getAllocatedRange().autoFitRows();
        }*/
        /* CellRange range = worksheet.getRange();
        for (IXLSRange row : range.getRows()) {
            for (IXLSRange cr : row.getColumns()) {
                CellRange xCell = worksheet.getCellRange(cr.getRangeAddress());
                CellStyle style = xCell.getCellStyle();
                // xCell.autoFitRows();
                // xCell.autoFitColumns();
                style.setWrapText(true);
                style.setShrinkToFit(true);
            }
        }*/
    }
}
